<?xml version="1.0" ?>
<PluginList>
  <Plugin id="SE Impulse Response2" name="Impulse Response" category="Diagnostic" helpUrl="SE Impulse Response.html" >
    <Parameters>
      <Parameter id="0" datatype="blob" name="Results" private="true" ignorePatchChange="true" persistant="false" />
      <Parameter id="1" datatype="float" name="sampleRate" private="true" ignorePatchChange="true" persistant="false" />
    </Parameters>
    <Audio>
      <Pin name="Impulse In" datatype="float" rate="audio" />
      <Pin name="Signal in" datatype="float" rate="audio" />
      <Pin name="Mode" datatype="enum" metadata="Impulse Response,Frequency Response" default="1" />
      <Pin name="Results" datatype="blob" direction="out" private="true" parameterId="0" />
      <Pin name="sampleRate" datatype="float" direction="out" private="true" parameterId="1" />
    </Audio>
    <GUI graphicsApi="GmpiGui">
      <Pin name="Results" datatype="blob" private="true" parameterId="0" />
      <Pin name="sampleRate" datatype="float" private="true" parameterId="1" />
    </GUI>
  </Plugin>
  
  <Plugin id="SE Keyboard (MIDI)" name="Keyboard (MIDI)" category="Controls">
    <GUI graphicsApi="GmpiGui" />
    <Audio>
      <Pin name="Channel" datatype="enum" ignorePatchChange="true" metadata="All=-1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16" />
      <Pin name="MIDI Out" datatype="midi" direction="out" />
    </Audio>
  </Plugin>
  
  <Plugin id="SE Midi Monitor" name="Midi Monitor" category="Diagnostic" >
    <Parameters>
      <Parameter id="0" datatype="string" ignorePatchChange="true" persistant="false" />
    </Parameters>
    <Audio>
      <Pin name="MIDI In" datatype="midi" />
      <Pin name="Disp Out" datatype="string" direction="out" private="true" parameterId="0" />
    </Audio>
    <GUI graphicsApi="GmpiGui">
      <Pin name="Disp In" datatype="string" private="true" parameterId="0" />
    </GUI>
  </Plugin>

  <Plugin id="SE Monitor" name="Monitor" category="Diagnostic" voiceMonitorIgnore="true" >
    <Parameters>
      <Parameter id="0" datatype="string" ignorePatchChange="true" persistant="false" />
    </Parameters>
    <Audio>
      <Pin name="MIDI In" datatype="midi" />
      <Pin name="Channel" datatype="enum" default="-1" ignorePatchChange="true" metadata="All=-1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16" />
      <Pin name="Signal in" datatype="float" rate="audio" linearInput="true" />
      <Pin name="Signal Out" datatype="float" rate="audio" direction="out" />
      <Pin name="Print Time" datatype="float" isMinimised="true" />
      <Pin name="Print Input Stat Changes" datatype="bool" default="1" isMinimised="true" />
      <Pin name="Print &apos;tick&apos; processing" datatype="bool" isMinimised="true" />
      <Pin name="Disp Mode" datatype="enum" default="2" metadata="Func List, Func Changes, In Voltage, Denormal Count" />
      <Pin name="Use Trace Window" datatype="bool" isMinimised="true" />
      <Pin name="Engine Overload test" datatype="bool" isMinimised="true" />
      <Pin name="Disp Out" datatype="string" direction="out" private="true" parameterId="0" />
    </Audio>
    <GUI graphicsApi="GmpiGui">
      <Pin name="Disp In" datatype="string" private="true" parameterId="0" />
    </GUI>
  </Plugin>
  
  <Plugin id="SE Waveshaper3 XP" name="Waveshaper3" category="Modifiers">
    <Parameters>
      <Parameter id="0" datatype="string" name="Shape" default="(-5.0,-5.0)(-4.0,-4.0)(-3.0,-3.0)(-2.0,-2.0)(-1.0,-1.0)(0.0,0.0)(1.0,1.0)(2.0,2.0)(3.0,3.0)(4.0,4.0)(5.0,5.0)" />
    </Parameters>
    <Audio>
      <Pin name="Signal In" datatype="float" rate="audio" />
      <Pin name="Signal Out" datatype="float" rate="audio" direction="out" />
      <Pin name="shape" datatype="string" private="true" parameterId="0" />
    </Audio>
    <GUI graphicsApi="GmpiGui">
      <Pin name="Shape" datatype="string" private="true" parameterId="0" />
    </GUI>
  </Plugin>

  <Plugin id="SE Waveshaper2 XP" name="Waveshaper2" category="Modifiers" >
    <Parameters>
      <Parameter id="0" datatype="string" name="Shape" default="5 * sin(x/PI)" />
    </Parameters>
    <Audio>
      <Pin name="Shape" datatype="string" private="true" parameterId="0" />
      <Pin name="Input" datatype="float" rate="audio" />
      <Pin name="Output" datatype="float" rate="audio" direction="out" />
    </Audio>
    <GUI graphicsApi="GmpiGui">
      <Pin name="Shape" datatype="string" private="true" parameterId="0" />
    </GUI>
  </Plugin>
  <Plugin id="SE Volt Meter" name="Volt Meter" category="Controls">
    <Parameters>
      <Parameter id="0" datatype="float" name="patchValue" ignorePatchChange="true" persistant="false"/>
    </Parameters>
    <Audio>
      <Pin name="Signal in" datatype="float" rate="audio" linearInput="true" />
      <Pin name="Mode" datatype="enum" isMinimised="true" metadata="DC,AC RMS" />
      <Pin name="Update Rate" datatype="enum" default="2" isMinimised="true" metadata="Regular=2, Fast=5" />
      <Pin name="patchValue" datatype="float" direction="out" private="true" parameterId="0" />
    </Audio>
    <GUI graphicsApi="GmpiGui">
      <Pin id="6" name="patchValue" datatype="float" direction="in" private="true" parameterId="0" />
      <Pin name="Title" datatype="string" isMinimised="true" />
    </GUI>
  </Plugin>
  
  <Plugin id="SE Freq Analyser2" name="Freq Analyser2" category="Controls" graphicsApi="GmpiGui">
    <Parameters>
      <Parameter id="0" name="Capture Data A" datatype="blob" private="true" ignorePatchChange="true" persistant="false"/>
    </Parameters>
    <Audio>
      <Pin name="Capture Data A" direction="out" datatype="blob" parameterId="0" private="true"/>
      <Pin name="Signal in" datatype="float" rate="audio" linearInput="true" />
      <Pin name="FFT Size" datatype="enum" isMinimised="true" default="2048" metadata="1024=1024,2048=2048,4096=4096,8192=8192,16384=16384" />
    </Audio>
    <GUI>
      <Pin name="Capture Data A" datatype="blob" parameterId="0" private="true" />
      <Pin name="Mode" datatype="enum" isMinimised="true" metadata="Log,Linear" />
      <Pin name="dB High" datatype="int" isMinimised="true" default="20" />
      <Pin name="dB Low" datatype="int" isMinimised="true" default="-80" />
    </GUI>
  </Plugin>
  
  <!-- Drop-in replacement for KeyBoard2 -->
  <Plugin id="SE Keyboard2" name="Keyboard (CV)" category="Controls" helpUrl="Keyboard2.html" graphicsApi="GmpiGui" polyphonicSource="true" polyphonic="true" cloned="true">
    <Audio>
      <Pin name="PitchX" datatype="float" private="true" hostConnect="Voice/Pitch" />
      <Pin name="TriggerX" datatype="float" private="true" hostConnect="Voice/Trigger" />
      <Pin name="GateX" datatype="float" private="true" hostConnect="Voice/Gate" />
      <Pin name="VelocityKeyOnX" datatype="float" private="true" hostConnect="Voice/VelocityKeyOn" />
      <Pin name="VelocityKeyOffX" datatype="float" private="true" hostConnect="Voice/VelocityKeyOff" />
      <Pin name="AftertouchX" datatype="float" private="true" hostConnect="Voice/Aftertouch" />
      <Pin name="Unused" datatype="int" private="true" />
      <Pin name="VoiceReset" datatype="float" private="true" isPolyphonic="true" hostConnect="Voice/Active" />
      <Pin name="Bender" datatype="float" private="true" hostConnect="Bender" />
      <Pin name="Glide Type" datatype="enum" metadata="Constant Time,Constant Rate" />
      <Pin name="Glide Rate" datatype="float" rate="audio" />
      <Pin name="Bend Range" datatype="float" rate="audio" default="0.2" />
      <Pin name="Pitch" datatype="float" rate="audio" direction="out" />
      <Pin name="Trigger" datatype="float" rate="audio" direction="out" />
      <Pin name="Gate" datatype="float" rate="audio" direction="out" />
      <Pin name="Velocity" datatype="float" rate="audio" direction="out" />
      <Pin name="Aftertouch" datatype="float" rate="audio" direction="out" />
      <Pin name="Raw Pitch" datatype="float" direction="out" />
      <Pin name="Raw Velocity-On" datatype="float" direction="out" />
      <Pin name="Raw Velocity-Off" datatype="float" direction="out" />
      <Pin name="HoldPedal" datatype="float" private="true" hostConnect="HoldPedal" />
    </Audio>
    <GUI>
      <!--
      <Pin name="Pitch" datatype="float" private="true" isPolyphonic="true" hostConnect="Voice/Pitch" />
      -->
      <Pin id="2" name="Gate" datatype="float" private="true" isPolyphonic="true" hostConnect="Voice/Gate" />
      <Pin name="Velocity" datatype="float" private="true" isPolyphonic="true" hostConnect="Voice/VelocityKeyOn" />
    </GUI>
  </Plugin>
  
  <!-- Drop-in replacement for classic slider -->
  <Plugin id="SE Slider" name="Slider" category="Debug/DirectX" graphicsApi="GmpiGui">
    <Parameters>
      <Parameter id="0" datatype="float" name="s1" />
    </Parameters>
    <Audio>
      <Pin name="S0" datatype="float" private="true" parameterId="0" />
      <Pin id="6" name="Signal Out" datatype="float" rate = "audio" direction="out" autoConfigureParameter="true" />
    </Audio>
    <GUI>
      <Pin id="13" name="Value In" datatype="float" private="true" parameterId="0" />
      <Pin id="14" name="Hint" datatype="string" private="true" />
      <Pin id="15" name="Appearance" datatype="enum" default="0" isMinimised="true" metadata="Slider,H-Slider=2,Knob,Button, Button (toggle), Knob (small)=7, Button(small), Button (small toggle)" />
      <Pin id="16" name="Title" datatype="string" isMinimised="true" />
      <Pin id="17" name="Normalized" datatype="float" private="true" parameterId="0" parameterField="Normalized" />

      <Pin name="Menu Items" datatype="string" private="true" parameterId="0" parameterField="MenuItems" />
      <Pin name="Menu Selection" datatype="int" private="true" parameterId="0" parameterField="MenuSelection" />
      <Pin name="Mouse Down" datatype="bool" private="true" parameterId="0" parameterField="Grab" />
      <Pin name="RangeLo" datatype="float" private="true" parameterId="0" parameterField="RangeMinimum" />
      <Pin name="RangeHi" datatype="float" private="true" parameterId="0" parameterField="RangeMaximum" />
      <Pin name="Show Readout" datatype="bool" default="1" isMinimised="true" redrawOnChange="true"/>
      <!--
      <Pin name="Show Title On Panel" datatype="bool" default="1" isMinimised="true" redrawOnChange="true"/>
      -->
    </GUI>
  </Plugin>
  
  <!-- New improved Slider -->
  <Plugin id="SE Slider2" name="Slider2" category="Debug" graphicsApi="GmpiGui">
    <Parameters>
      <Parameter id="0" datatype="float" name="s1" />
    </Parameters>
    <Audio>
      <Pin name="S0" datatype="float" private="true" parameterId="0" />
      <Pin name="Signal Out" datatype="float" rate = "audio" direction="out" autoConfigureParameter="true" />
    </Audio>
    <GUI>
      <Pin name="Value In" datatype="float" private="true" parameterId="0" />
      <Pin name="Name In" datatype="string" private="true" parameterId="0" parameterField="ShortName" />
      <Pin name="Menu Items" datatype="string" private="true" parameterId="0" parameterField="MenuItems" />
      <Pin name="Menu Selection" datatype="int" private="true" parameterId="0" parameterField="MenuSelection" />
      <Pin name="Mouse Down" datatype="bool" private="true" parameterId="0" parameterField="Grab" />
      <Pin name="RangeLo" datatype="float" private="true" parameterId="0" parameterField="RangeMinimum" />
      <Pin name="RangeHi" datatype="float" private="true" parameterId="0" parameterField="RangeMaximum" />
      <Pin name="Reset Value" datatype="float" isMinimised="true"/>
      <Pin name="Appearance" datatype="enum" default="0" isMinimised="true" metadata="None=-1,Slider,H-Slider=2,Knob,Button, Button (toggle), Knob (small)=7, Button(small), Button (small toggle)" />
      <Pin name="Show Readout" datatype="bool" default="1" isMinimised="true" redrawOnChange="true"/>
      <Pin name="Show Title On Panel" datatype="bool" default="1" isMinimised="true" redrawOnChange="true"/>
    </GUI>
  </Plugin>

  <Plugin id="SE List Entry" name="List Entry" category="Debug/DirectX" graphicsApi="GmpiGui">
    <Parameters>
      <Parameter id="0" datatype="enum" name="s1" />
    </Parameters>
    <Audio>
      <Pin name="Value In" datatype="int" private="true" parameterId="0" />
      <Pin name="Value Out" datatype="enum" direction="out" autoConfigureParameter="true" />
    </Audio>
    <GUI>
      <Pin id="10" name="Value In" datatype="int" private="true" parameterId="0" />
      <Pin name="Hint" datatype="string" private="true" />
      <Pin name="EnumList" datatype="string" private="true" parameterId="0" parameterField="EnumList" />
      <Pin name="Appearance" datatype="enum" default="0" isMinimised="true" metadata="Dropdown, LED Stack, LED Stack (labelled), Selector, Button Stack, Rot Switch=5,Rot Switch (no labels), Up/Down Select" />
 <!--
      <Pin name="Show Title On Panel" datatype="bool" default="1" isMinimised="true" redrawOnChange="true"/>
 -->
      <Pin name="Title" datatype="string" isMinimised="true" />
      
      <Pin name="Menu Items" datatype="string" private="true" parameterId="0" parameterField="MenuItems" />
      <Pin name="Menu Selection" datatype="int" private="true" parameterId="0" parameterField="MenuSelection" />
    </GUI>
  </Plugin>
  
  <Plugin id="SE Text Entry" name="Text Entry" category="Debug/DirectX" graphicsApi="GmpiGui">
    <Parameters>
      <Parameter id="0" datatype="string" name="patchValue" />
    </Parameters>
    <Audio>
      <Pin name="patchValue" datatype="string" default="0" private="true" parameterId="0" />
      <Pin name="Text Out" datatype="string" direction="out" autoConfigureParameter="true" />
    </Audio>
    <GUI>
      <Pin id="9" name="patchValue" datatype="string" private="true" parameterId="0" />
      <Pin name="Extension" datatype="string" private="true" parameterId="0" parameterField="FileExtension" />
      <Pin name="Hint" datatype="string" isMinimised="true" />
      <Pin name="Title" datatype="string" isMinimised="true" />
      <!-- Only Here to ensure Pin indexs line up on XPSV -->
      <Pin name="Mouse Down" datatype="bool" private="true" parameterId="0" parameterField="Grab" />
    </GUI>
  </Plugin>
  
  <Plugin id="SE Scope3 XP" name="Scope3" category="Controls" graphicsApi="GmpiGui" >
    <Parameters>
      <Parameter id="0" name="Capture Data A" datatype="blob" private="true" ignorePatchChange="true" isPolyphonic="true" persistant="false"/>
      <Parameter id="1" name="Capture Data B" datatype="blob" private="true" ignorePatchChange="true" isPolyphonic="true" persistant="false"/>
      <Parameter id="2" name="polyDetect" datatype="bool" private="true" ignorePatchChange="true" persistant="false"/>
    </Parameters>
    <Audio>
      <Pin id="0" name="Capture Data A" direction="out" datatype="blob"  parameterId="0" private="true" isPolyphonic="true"/>
      <Pin id="1" name="Capture Data B" direction="out" datatype="blob"  parameterId="1" private="true" isPolyphonic="true"/>
      <Pin id="2" name="Signal A" datatype="float" rate="audio"/>
      <Pin id="3" name="Signal B" datatype="float" rate="audio"/>
      <Pin id="4" name="VoiceActive" hostConnect="Voice/Active" datatype="float" isPolyphonic="true" />
      <Pin id="5" name="polydetect" direction="out" datatype="bool" parameterId="2"/>
    </Audio>
    <GUI>
      <Pin id="0" name="Capture Data A" datatype="blob" parameterId="0" private="true" isPolyphonic="true"/>
      <Pin id="1" name="Capture Data B" datatype="blob" parameterId="1" private="true" isPolyphonic="true"/>
      <Pin id="3" name="VoiceGate" datatype="float" hostConnect="Voice/Gate" isPolyphonic="true" private="true"/>
      <Pin id="4" name="polydetect" datatype="bool" parameterId="2" />
    </GUI>
  </Plugin>
  <Plugin id="SE TrigScope3 XP" name="Triggered Scope" category="Diagnostic" graphicsApi="GmpiGui" >
    <Parameters>
      <Parameter id="0" name="Capture Data A" datatype="blob" private="true" ignorePatchChange="true" isPolyphonic="true" persistant="false"/>
      <Parameter id="1" name="Capture Data B" datatype="blob" private="true" ignorePatchChange="true" isPolyphonic="true" persistant="false"/>
      <Parameter id="2" name="polyDetect" datatype="bool" private="true" ignorePatchChange="true" persistant="false"/>
    </Parameters>
    <Audio>
      <Pin name="Trigger" datatype="float" rate="audio"/>
      <Pin name="Capture Data A" direction="out" datatype="blob"  parameterId="0" private="true" isPolyphonic="true"/>
      <Pin name="Capture Data B" direction="out" datatype="blob"  parameterId="1" private="true" isPolyphonic="true"/>
      <Pin name="Signal A" datatype="float" rate="audio"/>
      <Pin name="Signal B" datatype="float" rate="audio"/>
      <Pin name="VoiceActive" hostConnect="Voice/Active" datatype="float" isPolyphonic="true" />
      <Pin name="polydetect" direction="out" datatype="bool" parameterId="2"/>
    </Audio>
    <GUI>
      <Pin name="Capture Data A" direction="in" datatype="blob" parameterId="0" private="true" isPolyphonic="true"/>
      <Pin name="Capture Data B" direction="in" datatype="blob" parameterId="1" private="true" isPolyphonic="true"/>
      <Pin id="3" name="VoiceGate" direction="in" datatype="float" hostConnect="Voice/Gate" isPolyphonic="true" private="true"/>
      <Pin name="polydetect" direction="in" datatype="bool" parameterId="2" />
    </GUI>
  </Plugin>
</PluginList>
